#############################################################################

class CmdException(Exception):
    """Base exception"""
    def __init__(self, name, err):
        Exception.__init__(self)
        self.name_ = name
        self.err_ = err

#############################################################################

class CmdFailedException(CmdException):
    """Exception raised if error returned from executed command"""
    def __init__(self, name, err, ret=-1):
        CmdException.__init__(self, name, err)
        self.ret_ = ret

    def __str__(self):
        return "%s: \"%s\" (ret=%s)" % (self.name_, self.err_, self.ret_)

#############################################################################

class CmdBadArgException(CmdException):
    """Exception raised if arguments to command are known bad"""
    def __init__(self, name, err):
        CmdException.__init__(self, name, err)

    def __str__(self):
        return "%s: \"%s\"" % (self.name_, self.err_)
