import os

from hgutil.util import DirChanger, execCmd
from hgutil.exception import *

def pullRepos(repos, url=None):
    dir = DirChanger()
    try:
        dir.up(repos)
        if not os.path.isdir('.hg'):
            raise CmdBadArgException('hg-pull', repos + ' does not seem like a hg repos (no .hg/ found)')
        cmd = ['hg', 'pull']
        if url != None:
            cmd.append(url)
        execCmd(cmd, 'hg-pull')
    finally:
        dir.down()

def cloneRepos(url):
    execCmd(['hg', 'clone', '--noupdate', url], 'hg-clone')

def cleanupRepos(repos):
    dir = DirChanger()
    try:
        dir.up(repos)
        execCmd(['hg', 'up', 'null'], repos)
    finally:
        dir.down()

def syncRepos(url, repos, notify=None):
    if os.path.isdir(repos):
        pullRepos(repos, url)
    else:
        cloneRepos(url)
        if notify:
            notify(url)
