import os
import subprocess
import Queue

from exception import *

##############################################################################

class DirChanger(object):
    """Directory guard"""
    def __init__(self, dir=None, create=False, debug=False):
        """Save current directory and change to dir"""
        self.owd_ = os.path.abspath('.')
        self.debug_ = debug
        self.changed_ = False
        if dir:
            self.up(dir, create)

    def up(self, dir=None, create=False):
        if dir:
            if create and not os.path.isdir(dir):
                os.makedirs(dir)
            if self.debug_:
                print self.owd_, '->', dir
            os.chdir(dir)
            self.changed_ = True

    def down(self):
        if self.changed_:
            os.chdir(self.owd_)

##############################################################################

def execCmd(cmd, name, stdout=subprocess.PIPE):
    '''Default function to execute a Command on the shell'''
    proc = subprocess.Popen(cmd, stdout=stdout, stderr=subprocess.PIPE)
    (out, err) = proc.communicate()
    if proc.returncode != 0:
        raise CmdFailedException(name, err.splitlines()[0], proc.returncode)

##############################################################################

class QueueListBridge(object):
    '''Bridge to use Queue as list on the producer side'''
    def __init__(self, q):
        self.data_ = q
        if isinstance(q, Queue.Queue):
            self._append = lambda x, y: x.put(y)
        else:
            self._append = lambda x, y: x.append(y)

    def append(self, x):
        self._append(self.data_, x)

